package org.switchyard.quickstarts.camel.binding;

import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.component.http.SSLContextParametersSecureProtocolSocketFactory;
import org.apache.camel.util.jsse.KeyManagersParameters;
import org.apache.camel.util.jsse.KeyStoreParameters;
import org.apache.camel.util.jsse.SSLContextParameters;

import java.net.MalformedURLException;
import java.net.URL;
import java.security.cert.Certificate;
import java.io.*;

import javax.inject.Inject;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLPeerUnverifiedException;

import org.apache.commons.codec.binary.Base64;
import org.apache.commons.httpclient.protocol.Protocol;
import org.apache.commons.httpclient.protocol.ProtocolSocketFactory;
import org.apache.commons.httpclient.protocol.Protocol;
import org.apache.commons.httpclient.protocol.ProtocolSocketFactory;
import org.switchyard.component.bean.Reference;



public class GreetingServiceRoute extends RouteBuilder {
	

	
	private static String USER = "rick";
	private static String PASSWORD = "password";
	

	/**
	 * The Camel route is configured via this method.  The from endpoint is required to be a SwitchYard service.
	 */
	public void configure() {
		Processor myProcessor = new MyProcessor();
		from("switchyard://GreetingService").log(
				"Received message for 'GreetingService' : ${body}")
				.process(myProcessor)
				.log("Done processing");
	}
	
	
	
	class MyProcessor implements Processor {
		  public void process(Exchange exchange) throws Exception {
		    System.out.println("### Processor runs!  Got passed:" + exchange.getIn().getBody().toString());
		    
		       String authString = USER + ":" + PASSWORD;
		       System.out.println("auth string: " + authString);
		       byte[] authEncBytes = Base64.encodeBase64(authString.getBytes());
		       String authStringEnc = new String(authEncBytes);
		       System.out.println("Base64 encoded auth string: " + authStringEnc);

		       String https_url = "https://localhost:18443/A_SecuredServlet/SecuredSSLServlet";
		      URL url;
		      try {
		 
			     url = new URL(https_url);	     
			     HttpsURLConnection con = (HttpsURLConnection)url.openConnection();
			     con.setRequestMethod("GET");
			     con.setRequestProperty("Authorization", "Basic " + authStringEnc);
			     con.setRequestProperty("SomeProperty", "SomeValue");
			     
			     // make the call			
			 	   BufferedReader br = new BufferedReader(new InputStreamReader(con.getInputStream()));
			 	   String input;
			  
			 	   while ((input = br.readLine()) != null){
			 	      System.out.println(input);
			 	   }
			 	   br.close();
		 
		      } catch (MalformedURLException e) {
			     e.printStackTrace();
		      } catch (IOException e) {
			     e.printStackTrace();
		      }

		  }
		}

}
